package com.ruoyi.jjh.ent.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.jjh.declaration.entity.BmsFundingDetail;
import com.ruoyi.jjh.ent.entity.JSmartReminders;
import com.ruoyi.jjh.ent.mapper.JSmartRemindersMapper;
import com.ruoyi.jjh.ent.service.JSmartRemindersService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 智能提醒（j_smart_reminders）表业务实现层
 *
 * @author du
 * @since 2024/7/1 13:33
 */
@Service
public class JSmartRemindersServiceImpl extends ServiceImpl<JSmartRemindersMapper, JSmartReminders> implements JSmartRemindersService {

    /**
     * 分页查询所有数据
     *
     * @param page            分页对象
     * @param jSmartReminders 查询实体
     * @return 所有数据
     */
    @Override
    public Page<JSmartReminders> page(Page<JSmartReminders> page, JSmartReminders jSmartReminders) {
        return baseMapper.page(page, jSmartReminders);
    }

    /**
     * 新增数据
     *
     * @param jSmartReminders 实体对象
     * @return 新增结果
     */
    @Override
    public int add(JSmartReminders jSmartReminders) {
        if (jSmartReminders.getAlertManner() == 2) {
            List<JSmartReminders> list = lambdaQuery().eq(JSmartReminders::getAlertManner, 2).list();
            if (list.size() >= 2) {
                throw new ServiceException("已有不定期提醒,不可新增!");
            }
            if ((jSmartReminders.getAlertRecipients() == 1 && jSmartReminders.getAlertType() == 1)
                    || (jSmartReminders.getAlertRecipients() == 2 && jSmartReminders.getAlertType() == 2)) {
                save(jSmartReminders);
            } else {
                throw new ServiceException("参数请求错误");
            }
        }
        return 0;
    }
}

